diff --git a/test/strings/basic.string/string.ops/string.accessors/data.pass.cpp b/test/strings/basic.string/string.ops/string.accessors/data.pass.cpp
index c2c57f6..917248f 100644
--- a/test/strings/basic.string/string.ops/string.accessors/data.pass.cpp
+++ b/test/strings/basic.string/string.ops/string.accessors/data.pass.cpp
@@ -14,7 +14,7 @@
 #include <string>
 #include <cassert>
 
-#include "../../min_allocator.h"
+#include "min_allocator.h"
 
 template <class S>
 void
diff --git a/test/strings/basic.string/string.ops/string.accessors/get_allocator.pass.cpp b/test/strings/basic.string/string.ops/string.accessors/get_allocator.pass.cpp
index 8d99817..b3892d7 100644
--- a/test/strings/basic.string/string.ops/string.accessors/get_allocator.pass.cpp
+++ b/test/strings/basic.string/string.ops/string.accessors/get_allocator.pass.cpp
@@ -15,7 +15,7 @@
 #include <cassert>
 
 #include "../../test_allocator.h"
-#include "../../min_allocator.h"
+#include "min_allocator.h"
 
 template <class S>
 void
diff --git a/test/strings/basic.string/string.ops/string_compare/pointer.pass.cpp b/test/strings/basic.string/string.ops/string_compare/pointer.pass.cpp
index c13905e..dda7428 100644
--- a/test/strings/basic.string/string.ops/string_compare/pointer.pass.cpp
+++ b/test/strings/basic.string/string.ops/string_compare/pointer.pass.cpp
@@ -14,7 +14,7 @@
 #include <string>
 #include <cassert>
 
-#include "../../min_allocator.h"
+#include "min_allocator.h"
 
 int sign(int x)
 {
diff --git a/test/strings/basic.string/string.ops/string_compare/size_size_pointer.pass.cpp b/test/strings/basic.string/string.ops/string_compare/size_size_pointer.pass.cpp
index ca4b067..9ed58a3 100644
--- a/test/strings/basic.string/string.ops/string_compare/size_size_pointer.pass.cpp
+++ b/test/strings/basic.string/string.ops/string_compare/size_size_pointer.pass.cpp
@@ -15,7 +15,7 @@
 #include <stdexcept>
 #include <cassert>
 
-#include "../../min_allocator.h"
+#include "min_allocator.h"
 
 int sign(int x)
 {
diff --git a/test/strings/basic.string/string.ops/string_compare/size_size_pointer_size.pass.cpp b/test/strings/basic.string/string.ops/string_compare/size_size_pointer_size.pass.cpp
index c94eaef..ee804d9 100644
--- a/test/strings/basic.string/string.ops/string_compare/size_size_pointer_size.pass.cpp
+++ b/test/strings/basic.string/string.ops/string_compare/size_size_pointer_size.pass.cpp
@@ -15,7 +15,7 @@
 #include <stdexcept>
 #include <cassert>
 
-#include "../../min_allocator.h"
+#include "min_allocator.h"
 
 int sign(int x)
 {
diff --git a/test/strings/basic.string/string.ops/string_compare/size_size_string.pass.cpp b/test/strings/basic.string/string.ops/string_compare/size_size_string.pass.cpp
index 4312e27..3deb617 100644
--- a/test/strings/basic.string/string.ops/string_compare/size_size_string.pass.cpp
+++ b/test/strings/basic.string/string.ops/string_compare/size_size_string.pass.cpp
@@ -15,7 +15,7 @@
 #include <stdexcept>
 #include <cassert>
 
-#include "../../min_allocator.h"
+#include "min_allocator.h"
 
 int sign(int x)
 {
diff --git a/test/strings/basic.string/string.ops/string_compare/size_size_string_size_size.pass.cpp b/test/strings/basic.string/string.ops/string_compare/size_size_string_size_size.pass.cpp
index 8fa23b7..29eba9a 100644
--- a/test/strings/basic.string/string.ops/string_compare/size_size_string_size_size.pass.cpp
+++ b/test/strings/basic.string/string.ops/string_compare/size_size_string_size_size.pass.cpp
@@ -16,7 +16,7 @@
 #include <stdexcept>
 #include <cassert>
 
-#include "../../min_allocator.h"
+#include "min_allocator.h"
 
 int sign(int x)
 {
diff --git a/test/strings/basic.string/string.ops/string_compare/string.pass.cpp b/test/strings/basic.string/string.ops/string_compare/string.pass.cpp
index 58f5760..7de95a8 100644
--- a/test/strings/basic.string/string.ops/string_compare/string.pass.cpp
+++ b/test/strings/basic.string/string.ops/string_compare/string.pass.cpp
@@ -14,7 +14,7 @@
 #include <string>
 #include <cassert>
 
-#include "../../min_allocator.h"
+#include "min_allocator.h"
 
 int sign(int x)
 {
diff --git a/test/strings/basic.string/string.ops/string_find.first.not.of/char_size.pass.cpp b/test/strings/basic.string/string.ops/string_find.first.not.of/char_size.pass.cpp
index 302f725..590173e 100644
--- a/test/strings/basic.string/string.ops/string_find.first.not.of/char_size.pass.cpp
+++ b/test/strings/basic.string/string.ops/string_find.first.not.of/char_size.pass.cpp
@@ -14,7 +14,7 @@
 #include <string>
 #include <cassert>
 
-#include "../../min_allocator.h"
+#include "min_allocator.h"
 
 template <class S>
 void
diff --git a/test/strings/basic.string/string.ops/string_find.first.not.of/pointer_size.pass.cpp b/test/strings/basic.string/string.ops/string_find.first.not.of/pointer_size.pass.cpp
index 66b21ae..53d3a95 100644
--- a/test/strings/basic.string/string.ops/string_find.first.not.of/pointer_size.pass.cpp
+++ b/test/strings/basic.string/string.ops/string_find.first.not.of/pointer_size.pass.cpp
@@ -14,7 +14,7 @@
 #include <string>
 #include <cassert>
 
-#include "../../min_allocator.h"
+#include "min_allocator.h"
 
 template <class S>
 void
diff --git a/test/strings/basic.string/string.ops/string_find.first.not.of/pointer_size_size.pass.cpp b/test/strings/basic.string/string.ops/string_find.first.not.of/pointer_size_size.pass.cpp
index 4416b82..14ac4b2 100644
--- a/test/strings/basic.string/string.ops/string_find.first.not.of/pointer_size_size.pass.cpp
+++ b/test/strings/basic.string/string.ops/string_find.first.not.of/pointer_size_size.pass.cpp
@@ -14,7 +14,7 @@
 #include <string>
 #include <cassert>
 
-#include "../../min_allocator.h"
+#include "min_allocator.h"
 
 template <class S>
 void
diff --git a/test/strings/basic.string/string.ops/string_find.first.not.of/string_size.pass.cpp b/test/strings/basic.string/string.ops/string_find.first.not.of/string_size.pass.cpp
index 3d28c24..4fb072f 100644
--- a/test/strings/basic.string/string.ops/string_find.first.not.of/string_size.pass.cpp
+++ b/test/strings/basic.string/string.ops/string_find.first.not.of/string_size.pass.cpp
@@ -14,7 +14,7 @@
 #include <string>
 #include <cassert>
 
-#include "../../min_allocator.h"
+#include "min_allocator.h"
 
 template <class S>
 void
diff --git a/test/strings/basic.string/string.ops/string_find.first.of/char_size.pass.cpp b/test/strings/basic.string/string.ops/string_find.first.of/char_size.pass.cpp
index fd64fdf..32d0e86 100644
--- a/test/strings/basic.string/string.ops/string_find.first.of/char_size.pass.cpp
+++ b/test/strings/basic.string/string.ops/string_find.first.of/char_size.pass.cpp
@@ -14,7 +14,7 @@
 #include <string>
 #include <cassert>
 
-#include "../../min_allocator.h"
+#include "min_allocator.h"
 
 template <class S>
 void
diff --git a/test/strings/basic.string/string.ops/string_find.first.of/pointer_size.pass.cpp b/test/strings/basic.string/string.ops/string_find.first.of/pointer_size.pass.cpp
index 59e00de..6dd176d 100644
--- a/test/strings/basic.string/string.ops/string_find.first.of/pointer_size.pass.cpp
+++ b/test/strings/basic.string/string.ops/string_find.first.of/pointer_size.pass.cpp
@@ -14,7 +14,7 @@
 #include <string>
 #include <cassert>
 
-#include "../../min_allocator.h"
+#include "min_allocator.h"
 
 template <class S>
 void
diff --git a/test/strings/basic.string/string.ops/string_find.first.of/pointer_size_size.pass.cpp b/test/strings/basic.string/string.ops/string_find.first.of/pointer_size_size.pass.cpp
index 0c21a02..9e98a6a 100644
--- a/test/strings/basic.string/string.ops/string_find.first.of/pointer_size_size.pass.cpp
+++ b/test/strings/basic.string/string.ops/string_find.first.of/pointer_size_size.pass.cpp
@@ -14,7 +14,7 @@
 #include <string>
 #include <cassert>
 
-#include "../../min_allocator.h"
+#include "min_allocator.h"
 
 template <class S>
 void
diff --git a/test/strings/basic.string/string.ops/string_find.first.of/string_size.pass.cpp b/test/strings/basic.string/string.ops/string_find.first.of/string_size.pass.cpp
index d7db16f..e409edc 100644
--- a/test/strings/basic.string/string.ops/string_find.first.of/string_size.pass.cpp
+++ b/test/strings/basic.string/string.ops/string_find.first.of/string_size.pass.cpp
@@ -14,7 +14,7 @@
 #include <string>
 #include <cassert>
 
-#include "../../min_allocator.h"
+#include "min_allocator.h"
 
 template <class S>
 void
diff --git a/test/strings/basic.string/string.ops/string_find.last.not.of/char_size.pass.cpp b/test/strings/basic.string/string.ops/string_find.last.not.of/char_size.pass.cpp
index f6ce46a..b130f92 100644
--- a/test/strings/basic.string/string.ops/string_find.last.not.of/char_size.pass.cpp
+++ b/test/strings/basic.string/string.ops/string_find.last.not.of/char_size.pass.cpp
@@ -14,7 +14,7 @@
 #include <string>
 #include <cassert>
 
-#include "../../min_allocator.h"
+#include "min_allocator.h"
 
 template <class S>
 void
diff --git a/test/strings/basic.string/string.ops/string_find.last.not.of/pointer_size.pass.cpp b/test/strings/basic.string/string.ops/string_find.last.not.of/pointer_size.pass.cpp
index 47c6d7f..3e6bd9d 100644
--- a/test/strings/basic.string/string.ops/string_find.last.not.of/pointer_size.pass.cpp
+++ b/test/strings/basic.string/string.ops/string_find.last.not.of/pointer_size.pass.cpp
@@ -14,7 +14,7 @@
 #include <string>
 #include <cassert>
 
-#include "../../min_allocator.h"
+#include "min_allocator.h"
 
 template <class S>
 void
diff --git a/test/strings/basic.string/string.ops/string_find.last.not.of/pointer_size_size.pass.cpp b/test/strings/basic.string/string.ops/string_find.last.not.of/pointer_size_size.pass.cpp
index f131b96..4db7762 100644
--- a/test/strings/basic.string/string.ops/string_find.last.not.of/pointer_size_size.pass.cpp
+++ b/test/strings/basic.string/string.ops/string_find.last.not.of/pointer_size_size.pass.cpp
@@ -14,7 +14,7 @@
 #include <string>
 #include <cassert>
 
-#include "../../min_allocator.h"
+#include "min_allocator.h"
 
 template <class S>
 void
diff --git a/test/strings/basic.string/string.ops/string_find.last.not.of/string_size.pass.cpp b/test/strings/basic.string/string.ops/string_find.last.not.of/string_size.pass.cpp
index 6de6326..ba93adb 100644
--- a/test/strings/basic.string/string.ops/string_find.last.not.of/string_size.pass.cpp
+++ b/test/strings/basic.string/string.ops/string_find.last.not.of/string_size.pass.cpp
@@ -14,7 +14,7 @@
 #include <string>
 #include <cassert>
 
-#include "../../min_allocator.h"
+#include "min_allocator.h"
 
 template <class S>
 void
diff --git a/test/strings/basic.string/string.ops/string_find.last.of/char_size.pass.cpp b/test/strings/basic.string/string.ops/string_find.last.of/char_size.pass.cpp
index 32aa77d..12765b7 100644
--- a/test/strings/basic.string/string.ops/string_find.last.of/char_size.pass.cpp
+++ b/test/strings/basic.string/string.ops/string_find.last.of/char_size.pass.cpp
@@ -14,7 +14,7 @@
 #include <string>
 #include <cassert>
 
-#include "../../min_allocator.h"
+#include "min_allocator.h"
 
 template <class S>
 void
diff --git a/test/strings/basic.string/string.ops/string_find.last.of/pointer_size.pass.cpp b/test/strings/basic.string/string.ops/string_find.last.of/pointer_size.pass.cpp
index cfe71d2..f1b447c 100644
--- a/test/strings/basic.string/string.ops/string_find.last.of/pointer_size.pass.cpp
+++ b/test/strings/basic.string/string.ops/string_find.last.of/pointer_size.pass.cpp
@@ -14,7 +14,7 @@
 #include <string>
 #include <cassert>
 
-#include "../../min_allocator.h"
+#include "min_allocator.h"
 
 template <class S>
 void
diff --git a/test/strings/basic.string/string.ops/string_find.last.of/pointer_size_size.pass.cpp b/test/strings/basic.string/string.ops/string_find.last.of/pointer_size_size.pass.cpp
index 7d82dc0..7f96e63 100644
--- a/test/strings/basic.string/string.ops/string_find.last.of/pointer_size_size.pass.cpp
+++ b/test/strings/basic.string/string.ops/string_find.last.of/pointer_size_size.pass.cpp
@@ -14,7 +14,7 @@
 #include <string>
 #include <cassert>
 
-#include "../../min_allocator.h"
+#include "min_allocator.h"
 
 template <class S>
 void
diff --git a/test/strings/basic.string/string.ops/string_find.last.of/string_size.pass.cpp b/test/strings/basic.string/string.ops/string_find.last.of/string_size.pass.cpp
index 98f78f8..351c672 100644
--- a/test/strings/basic.string/string.ops/string_find.last.of/string_size.pass.cpp
+++ b/test/strings/basic.string/string.ops/string_find.last.of/string_size.pass.cpp
@@ -14,7 +14,7 @@
 #include <string>
 #include <cassert>
 
-#include "../../min_allocator.h"
+#include "min_allocator.h"
 
 template <class S>
 void
diff --git a/test/strings/basic.string/string.ops/string_find/char_size.pass.cpp b/test/strings/basic.string/string.ops/string_find/char_size.pass.cpp
index 3c48a77..24e58fc 100644
--- a/test/strings/basic.string/string.ops/string_find/char_size.pass.cpp
+++ b/test/strings/basic.string/string.ops/string_find/char_size.pass.cpp
@@ -14,7 +14,7 @@
 #include <string>
 #include <cassert>
 
-#include "../../min_allocator.h"
+#include "min_allocator.h"
 
 template <class S>
 void
diff --git a/test/strings/basic.string/string.ops/string_find/pointer_size.pass.cpp b/test/strings/basic.string/string.ops/string_find/pointer_size.pass.cpp
index c3ea079..e00d7fd 100644
--- a/test/strings/basic.string/string.ops/string_find/pointer_size.pass.cpp
+++ b/test/strings/basic.string/string.ops/string_find/pointer_size.pass.cpp
@@ -14,7 +14,7 @@
 #include <string>
 #include <cassert>
 
-#include "../../min_allocator.h"
+#include "min_allocator.h"
 
 template <class S>
 void
diff --git a/test/strings/basic.string/string.ops/string_find/pointer_size_size.pass.cpp b/test/strings/basic.string/string.ops/string_find/pointer_size_size.pass.cpp
index f936651..3006c46 100644
--- a/test/strings/basic.string/string.ops/string_find/pointer_size_size.pass.cpp
+++ b/test/strings/basic.string/string.ops/string_find/pointer_size_size.pass.cpp
@@ -14,7 +14,7 @@
 #include <string>
 #include <cassert>
 
-#include "../../min_allocator.h"
+#include "min_allocator.h"
 
 template <class S>
 void
diff --git a/test/strings/basic.string/string.ops/string_find/string_size.pass.cpp b/test/strings/basic.string/string.ops/string_find/string_size.pass.cpp
index dc280d0..a89df4e 100644
--- a/test/strings/basic.string/string.ops/string_find/string_size.pass.cpp
+++ b/test/strings/basic.string/string.ops/string_find/string_size.pass.cpp
@@ -14,7 +14,7 @@
 #include <string>
 #include <cassert>
 
-#include "../../min_allocator.h"
+#include "min_allocator.h"
 
 template <class S>
 void
diff --git a/test/strings/basic.string/string.ops/string_rfind/char_size.pass.cpp b/test/strings/basic.string/string.ops/string_rfind/char_size.pass.cpp
index 8db67d9..cbc0c9b 100644
--- a/test/strings/basic.string/string.ops/string_rfind/char_size.pass.cpp
+++ b/test/strings/basic.string/string.ops/string_rfind/char_size.pass.cpp
@@ -14,7 +14,7 @@
 #include <string>
 #include <cassert>
 
-#include "../../min_allocator.h"
+#include "min_allocator.h"
 
 template <class S>
 void
diff --git a/test/strings/basic.string/string.ops/string_rfind/pointer_size.pass.cpp b/test/strings/basic.string/string.ops/string_rfind/pointer_size.pass.cpp
index 2b1efd3..450aebe 100644
--- a/test/strings/basic.string/string.ops/string_rfind/pointer_size.pass.cpp
+++ b/test/strings/basic.string/string.ops/string_rfind/pointer_size.pass.cpp
@@ -14,7 +14,7 @@
 #include <string>
 #include <cassert>
 
-#include "../../min_allocator.h"
+#include "min_allocator.h"
 
 template <class S>
 void
diff --git a/test/strings/basic.string/string.ops/string_rfind/pointer_size_size.pass.cpp b/test/strings/basic.string/string.ops/string_rfind/pointer_size_size.pass.cpp
index 5699cab..47baf40 100644
--- a/test/strings/basic.string/string.ops/string_rfind/pointer_size_size.pass.cpp
+++ b/test/strings/basic.string/string.ops/string_rfind/pointer_size_size.pass.cpp
@@ -14,7 +14,7 @@
 #include <string>
 #include <cassert>
 
-#include "../../min_allocator.h"
+#include "min_allocator.h"
 
 template <class S>
 void
diff --git a/test/strings/basic.string/string.ops/string_rfind/string_size.pass.cpp b/test/strings/basic.string/string.ops/string_rfind/string_size.pass.cpp
index d7c2e85..05e6e51 100644
--- a/test/strings/basic.string/string.ops/string_rfind/string_size.pass.cpp
+++ b/test/strings/basic.string/string.ops/string_rfind/string_size.pass.cpp
@@ -14,7 +14,7 @@
 #include <string>
 #include <cassert>
 
-#include "../../min_allocator.h"
+#include "min_allocator.h"
 
 template <class S>
 void
diff --git a/test/strings/basic.string/string.ops/string_substr/substr.pass.cpp b/test/strings/basic.string/string.ops/string_substr/substr.pass.cpp
index 9612b58..a73f70c 100644
--- a/test/strings/basic.string/string.ops/string_substr/substr.pass.cpp
+++ b/test/strings/basic.string/string.ops/string_substr/substr.pass.cpp
@@ -16,7 +16,7 @@
 #include <algorithm>
 #include <cassert>
 
-#include "../../min_allocator.h"
+#include "min_allocator.h"
 
 template <class S>
 void
diff --git a/test/support/min_allocator.h b/test/support/min_allocator.h
new file mode 100644
index 0000000..c0d28e5
--- /dev/null
+++ b/test/support/min_allocator.h
@@ -0,0 +1,252 @@
+#ifndef MIN_ALLOCATOR_H
+#define MIN_ALLOCATOR_H
+
+#if __cplusplus >= 201103L
+
+#include <memory>
+
+template <class T> class min_pointer;
+template <class T> class min_pointer<const T>;
+template <> class min_pointer<void>;
+template <> class min_pointer<const void>;
+template <class T> class min_allocator;
+
+template <>
+class min_pointer<const void>
+{
+    const void* ptr_;
+public:
+    min_pointer() noexcept = default;
+    min_pointer(std::nullptr_t) : ptr_(nullptr) {}
+    template <class T>
+    min_pointer(min_pointer<T> p) : ptr_(p.ptr_) {}
+
+    explicit operator bool() const {return ptr_ != nullptr;}
+
+    friend bool operator==(min_pointer x, min_pointer y) {return x.ptr_ == y.ptr_;}
+    friend bool operator!=(min_pointer x, min_pointer y) {return !(x == y);}
+    template <class U> friend class min_pointer;
+};
+
+template <>
+class min_pointer<void>
+{
+    void* ptr_;
+public:
+    min_pointer() noexcept = default;
+    min_pointer(std::nullptr_t) : ptr_(nullptr) {}
+    template <class T,
+              class = typename std::enable_if
+                       <
+                            !std::is_const<T>::value
+                       >::type
+             >
+    min_pointer(min_pointer<T> p) : ptr_(p.ptr_) {}
+
+    explicit operator bool() const {return ptr_ != nullptr;}
+
+    friend bool operator==(min_pointer x, min_pointer y) {return x.ptr_ == y.ptr_;}
+    friend bool operator!=(min_pointer x, min_pointer y) {return !(x == y);}
+    template <class U> friend class min_pointer;
+};
+
+template <class T>
+class min_pointer
+{
+    T* ptr_;
+
+    explicit min_pointer(T* p) : ptr_(p) {}
+public:
+    min_pointer() noexcept = default;
+    min_pointer(std::nullptr_t) : ptr_(nullptr) {}
+    explicit min_pointer(min_pointer<void> p) : ptr_(static_cast<T*>(p.ptr_)) {}
+
+    explicit operator bool() const {return ptr_ != nullptr;}
+    
+    typedef std::ptrdiff_t difference_type;
+    typedef T& reference;
+    typedef T* pointer;
+    typedef T value_type;
+    typedef std::random_access_iterator_tag iterator_category;
+
+    reference operator*() const {return *ptr_;}
+    pointer operator->() const {return ptr_;}
+
+    min_pointer& operator++() {++ptr_; return *this;}
+    min_pointer operator++(int) {min_pointer tmp(*this); ++ptr_; return tmp;}
+
+    min_pointer& operator--() {--ptr_; return *this;}
+    min_pointer operator--(int) {min_pointer tmp(*this); --ptr_; return tmp;}
+
+    min_pointer& operator+=(difference_type n) {ptr_ += n; return *this;}
+    min_pointer& operator-=(difference_type n) {ptr_ -= n; return *this;}
+
+    min_pointer operator+(difference_type n) const
+    {
+        min_pointer tmp(*this);
+        tmp += n;
+        return tmp;
+    }
+
+    friend min_pointer operator+(difference_type n, min_pointer x)
+    {
+        return x + n;
+    }
+
+    min_pointer operator-(difference_type n) const
+    {
+        min_pointer tmp(*this);
+        tmp -= n;
+        return tmp;
+    }
+
+    friend difference_type operator-(min_pointer x, min_pointer y)
+    {
+        return x.ptr_ - y.ptr_;
+    }
+
+    reference operator[](difference_type n) const {return ptr_[n];}
+
+    friend bool operator< (min_pointer x, min_pointer y) {return x.ptr_ < y.ptr_;}
+    friend bool operator> (min_pointer x, min_pointer y) {return y < x;}
+    friend bool operator<=(min_pointer x, min_pointer y) {return !(y < x);}
+    friend bool operator>=(min_pointer x, min_pointer y) {return !(x < y);}
+
+    static min_pointer pointer_to(T& t) {return min_pointer(std::addressof(t));}
+
+    friend bool operator==(min_pointer x, min_pointer y) {return x.ptr_ == y.ptr_;}
+    friend bool operator!=(min_pointer x, min_pointer y) {return !(x == y);}
+    template <class U> friend class min_pointer;
+    template <class U> friend class min_allocator;
+};
+
+template <class T>
+class min_pointer<const T>
+{
+    const T* ptr_;
+
+    explicit min_pointer(const T* p) : ptr_(p) {}
+public:
+    min_pointer() noexcept = default;
+    min_pointer(std::nullptr_t) : ptr_(nullptr) {}
+    min_pointer(min_pointer<T> p) : ptr_(p.ptr_) {}
+    explicit min_pointer(min_pointer<const void> p) : ptr_(static_cast<const T*>(p.ptr_)) {}
+
+    explicit operator bool() const {return ptr_ != nullptr;}
+
+    typedef std::ptrdiff_t difference_type;
+    typedef const T& reference;
+    typedef const T* pointer;
+    typedef const T value_type;
+    typedef std::random_access_iterator_tag iterator_category;
+
+    reference operator*() const {return *ptr_;}
+    pointer operator->() const {return ptr_;}
+
+    min_pointer& operator++() {++ptr_; return *this;}
+    min_pointer operator++(int) {min_pointer tmp(*this); ++ptr_; return tmp;}
+
+    min_pointer& operator--() {--ptr_; return *this;}
+    min_pointer operator--(int) {min_pointer tmp(*this); --ptr_; return tmp;}
+
+    min_pointer& operator+=(difference_type n) {ptr_ += n; return *this;}
+    min_pointer& operator-=(difference_type n) {ptr_ -= n; return *this;}
+
+    min_pointer operator+(difference_type n) const
+    {
+        min_pointer tmp(*this);
+        tmp += n;
+        return tmp;
+    }
+
+    friend min_pointer operator+(difference_type n, min_pointer x)
+    {
+        return x + n;
+    }
+
+    min_pointer operator-(difference_type n) const
+    {
+        min_pointer tmp(*this);
+        tmp -= n;
+        return tmp;
+    }
+
+    friend difference_type operator-(min_pointer x, min_pointer y)
+    {
+        return x.ptr_ - y.ptr_;
+    }
+
+    reference operator[](difference_type n) const {return ptr_[n];}
+
+    friend bool operator< (min_pointer x, min_pointer y) {return x.ptr_ < y.ptr_;}
+    friend bool operator> (min_pointer x, min_pointer y) {return y < x;}
+    friend bool operator<=(min_pointer x, min_pointer y) {return !(y < x);}
+    friend bool operator>=(min_pointer x, min_pointer y) {return !(x < y);}
+
+    static min_pointer pointer_to(const T& t) {return min_pointer(std::addressof(t));}
+
+    friend bool operator==(min_pointer x, min_pointer y) {return x.ptr_ == y.ptr_;}
+    friend bool operator!=(min_pointer x, min_pointer y) {return !(x == y);}
+    template <class U> friend class min_pointer;
+};
+
+template <class T>
+inline
+bool
+operator==(min_pointer<T> x, std::nullptr_t)
+{
+    return !static_cast<bool>(x);
+}
+
+template <class T>
+inline
+bool
+operator==(std::nullptr_t, min_pointer<T> x)
+{
+    return !static_cast<bool>(x);
+}
+
+template <class T>
+inline
+bool
+operator!=(min_pointer<T> x, std::nullptr_t)
+{
+    return static_cast<bool>(x);
+}
+
+template <class T>
+inline
+bool
+operator!=(std::nullptr_t, min_pointer<T> x)
+{
+    return static_cast<bool>(x);
+}
+
+template <class T>
+class min_allocator
+{
+public:
+    typedef T value_type;
+    typedef min_pointer<T> pointer;
+
+    min_allocator() = default;
+    template <class U>
+    min_allocator(min_allocator<U>) {}
+
+    pointer allocate(std::ptrdiff_t n)
+    {
+        return pointer(static_cast<T*>(::operator new(n*sizeof(T))));
+    }
+
+    void deallocate(pointer p, std::ptrdiff_t)
+    {
+        return ::operator delete(p.ptr_);
+    }
+
+    friend bool operator==(min_allocator, min_allocator) {return true;}
+    friend bool operator!=(min_allocator x, min_allocator y) {return !(x == y);}
+};
+
+#endif  // __cplusplus >= 201103L
+
+#endif  // MIN_ALLOCATOR_H
diff --git a/test/support/powerpc-darwin.h b/test/support/powerpc-darwin.h
new file mode 100644
index 0000000..60ba2a8
--- /dev/null
+++ b/test/support/powerpc-darwin.h
@@ -0,0 +1,23 @@
+#ifndef	__LIBCXX_TEST_SUPPORT_POWERPC_DARWIN_H__
+#define	__LIBCXX_TEST_SUPPORT_POWERPC_DARWIN_H__
+
+// control certain workarounds for the powerpc-darwin8 port
+
+/**
+	On PowerPC-darwin, ptrdiff_t is int, but size_t is unsigned long.
+	Tests that rely on is_same<make_unsigned<ptrdiff_t>, size_t>
+	will fail, but as long as the underlying integer types are
+	the same size (which is true on PPC32), then it is still safe.
+ */
+#define	PTRDIFF_T_VS_SIZE_T_DIFFER
+
+/**
+	PPC32 doesn't have native 64b atomic operations.
+	Thus, they must be emulated using mutex or lock.
+	TODO: provide specializations of struct atomic using std::mutex.
+	TODO: implement in compiler front-end
+	Undefine the following to enable mutex-based emulated 64b atomics.
+ */
+// #define	MISSING_64B_ATOMIC_OPS
+
+#endif	// __LIBCXX_TEST_SUPPORT_POWERPC_DARWIN_H__
diff --git a/test/testit b/test/testit
index 18b0814..ee2e5db 100755
--- a/test/testit
+++ b/test/testit
@@ -24,6 +24,7 @@ done
 
 cd ..
 LIBCXX_ROOT=`pwd`
+cpd=`echo "$LIBCXX_ROOT" | awk 'BEGIN{FS="/";}{print NF+1;}'`
 cd $origpath
 
 if [ -z "$CC" ]
@@ -36,6 +37,10 @@ then
 	fi
 fi
 
+if [ -z "$KEEP_EXE" ]
+then
+	KEEP_EXE=1
+fi
 if [ -z "$OPTIONS" ]
 then
 	OPTIONS="-std=c++11 -stdlib=libc++"
@@ -52,6 +57,7 @@ then
        SOURCE_LIB="-L$LIBCXX_ROOT/lib"
 fi
 
+# use distinct test executables (parallelizable)
 case $TRIPLE in
   *-*-mingw* | *-*-cygwin* | *-*-win*)
 	TEST_EXE=test.exe
@@ -74,14 +80,16 @@ IMPLEMENTED_FAIL=0
 IMPLEMENTED_PASS=0
 
 afunc() {
+	rwd=`pwd | cut -d/ -f$cpd-`
 	fail=0
 	pass=0
 	if (ls *.fail.cpp > /dev/null 2>&1)
 	then
 		for FILE in $(ls *.fail.cpp); do
-			if $CC $OPTIONS $HEADER_INCLUDE $SOURCE_LIB $FILE $LIBS -o ./$TEST_EXE > /dev/null 2>&1
+			t_exe=`basename $FILE .cpp`
+			if $CC $OPTIONS $HEADER_INCLUDE $SOURCE_LIB $FILE $LIBS -o ./$t_exe > /dev/null 2>&1
 			then
-				rm ./$TEST_EXE
+				test "$KEEP_EXE" = 1 || rm ./$t_exe
 				echo "$FILE should not compile"
 				fail=$(($fail+1))
 			else
@@ -93,24 +101,25 @@ afunc() {
 	if (ls *.pass.cpp > /dev/null 2>&1)
 	then
 		for FILE in $(ls *.pass.cpp); do
+		t_exe=`basename $FILE .cpp`
             if [ "$VERBOSE" ]
             then
              	echo "Running test: " $FILE
             fi
-			if $CC $OPTIONS $HEADER_INCLUDE $SOURCE_LIB $FILE $LIBS $(test $1 = no || echo $THREAD_FLAGS) -o ./$TEST_EXE
+			if $CC $OPTIONS $HEADER_INCLUDE $SOURCE_LIB $FILE $LIBS $(test $1 = no || echo $THREAD_FLAGS) -o ./$t_exe
 			then
-				if ./$TEST_EXE
+				if ./$t_exe
 				then
-					rm ./$TEST_EXE
+					test "$KEEP_EXE" = 1 || rm ./$t_exe
 					pass=$(($pass+1))
 				else
-					echo "`pwd`/$FILE failed at run time"
+					echo "$rwd/$FILE failed at run time"
 					echo "Compile line was:" $CC $OPTIONS $HEADER_INCLUDE $SOURCE_LIB $FILE $LIBS $(test $1 = no || echo $THREAD_FLAGS)
 					fail=$(($fail+1))
-					rm ./$TEST_EXE
+					test "$KEEP_EXE" = 1 || rm ./$t_exe
 				fi
 			else
-				echo "`pwd`/$FILE failed to compile"
+				echo "$rwd/$FILE failed to compile"
 				echo "Compile line was:" $CC $OPTIONS $HEADER_INCLUDE $SOURCE_LIB $FILE $LIBS $(test $1 = no || echo $THREAD_FLAGS)
 				fail=$(($fail+1))
 			fi
@@ -119,12 +128,12 @@ afunc() {
 
 	if [ $fail -gt 0 ]
 	then
-		echo "failed $fail tests in `pwd`"
+		echo "failed $fail tests in $rwd"
 		IMPLEMENTED_FAIL=$(($IMPLEMENTED_FAIL+1))
 	fi
 	if [ $pass -gt 0 ]
 	then
-		echo "passed $pass tests in `pwd`"
+		echo "passed $pass tests in $rwd"
 		if [ $fail -eq 0 ]
 		then
 			IMPLEMENTED_PASS=$((IMPLEMENTED_PASS+1))
@@ -132,7 +141,7 @@ afunc() {
 	fi
 	if [ $fail -eq 0 -a $pass -eq 0 ]
 	then
-		echo "not implemented:  `pwd`"
+		echo "not implemented:  $rwd"
 		UNIMPLEMENTED=$(($UNIMPLEMENTED+1))
 	fi
 
@@ -159,6 +168,7 @@ afunc no
 echo "****************************************************"
 echo "Results for `pwd`:"
 echo "using `$CC --version`"
+echo "  (`which $CC`)"
 echo "with $OPTIONS $HEADER_INCLUDE $SOURCE_LIB"
 echo "----------------------------------------------------"
 echo "sections without tests   : $UNIMPLEMENTED"
diff --git a/test/utilities/meta/meta.unary.prop.query/alignment_of.pass.cpp b/test/utilities/meta/meta.unary.prop.query/alignment_of.pass.cpp
index 9ee89c2..01a2f65 100644
--- a/test/utilities/meta/meta.unary.prop.query/alignment_of.pass.cpp
+++ b/test/utilities/meta/meta.unary.prop.query/alignment_of.pass.cpp
@@ -38,6 +38,10 @@ int main()
     test_alignment_of<char[3], 1>();
     test_alignment_of<int, 4>();
     test_alignment_of<double, 8>();
+#if (defined(__ppc__) && !defined(__ppc64__))
+    test_alignment_of<bool, 4>();	// 32-bit PPC has four byte bool
+#else
     test_alignment_of<bool, 1>();
+#endif
     test_alignment_of<unsigned, 4>();
 }
diff --git a/include/__config b/include/__config
index 4520739..6a0c416 100644
--- a/include/__config
+++ b/include/__config
@@ -569,12 +569,6 @@ template <unsigned> struct __static_assert_check {};
 #define _LIBCPP_WCTYPE_IS_MASK
 #endif
 
-#if defined(__APPLE__)
-#ifndef _LIBCPP_TRIVIAL_PAIR_COPY_CTOR
-#  define _LIBCPP_TRIVIAL_PAIR_COPY_CTOR 0
-#endif
-#endif
-
 #ifndef _LIBCPP_TRIVIAL_PAIR_COPY_CTOR
 #  define _LIBCPP_TRIVIAL_PAIR_COPY_CTOR 1
 #endif
